package rigger

import (
	"encoding/json"
	"fmt"
	"net/http"

	"ciyon/web/admin"
	c "ciyon/zciyon"
)

func mock_setwhere(post *c.CiyPost) (map[string]any, *c.CiySQL) {
	query := post.Getobj("query")
	csql := c.NewCiySQL("zc_ymock")
	csql.Where("name like", c.Getstr(query, "name"))
	csql.Where("upath like", c.Getstr(query, "upath"))
	csql.Where("ufunc like", c.Getstr(query, "ufunc"))
	order := c.Getstr(query, "order", "id desc")
	csql.Order(order)
	query["order"] = order
	return query, csql
}
func Mock_init(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	where, csql := mock_setwhere(post)
	pageno := post.Getint("pageno", 1)
	pagecount := post.Getint("pagecount", 10)
	csql.Limit(pageno, pagecount)
	rows, mainrowcount, err := c.CiyDB.Get(csql, post.Getint("count"))
	if err != nil {
		return c.ErrJSON(w, "读取错误", err)
	}
	rows = append(rows, map[string]any{
		"id":       0,
		"name":     "",
		"upath":    "",
		"ufunc":    "",
		"mockjson": "{\"code\":1}",
	})
	ret := map[string]any{}
	ret["where"] = where
	ret["pageno"] = pageno
	ret["pagecount"] = pagecount
	ret["count"] = mainrowcount
	ret["list"] = rows
	if post.Getbool("field") {
		field := map[string]map[string]any{}
		fshow := ""
		c.FieldAdd(&field, &fshow, -1, "mock", "Mock")
		c.FieldAdd(&field, &fshow, -1, "mockjson", "JSON")
		c.FieldAdd(&field, &fshow, -1, "_btn", "操作")
		field["mock"]["thwidth"] = "20em"
		field["mockjson"]["thwidth"] = "50em"
		ret["fshow"] = fshow
		ret["field"] = field
	}
	if post.Getbool("once") {
		once := map[string]any{}
		input := make([]map[string]any, 0)
		input = append(input, map[string]any{
			"form": "name",
			"type": "input",
			"name": "名称",
			"prop": ` style="width:8em;"`,
		})
		input = append(input, map[string]any{
			"form": "upath",
			"type": "input",
			"name": "类空间",
			"prop": ` style="width:8em;"`,
		})
		input = append(input, map[string]any{
			"form": "ufunc",
			"type": "input",
			"name": "函数名",
			"prop": ` style="width:8em;"`,
		})
		once["input"] = input
		ret["once"] = once
	}
	return c.SuccJSON(w, r, ret)
}
func Mock_update(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	if admin.Nopower(c.CiyDB, userid, "p942u") {
		return c.ErrJSON(w, "您未被授权操作")
	}
	id := post.Getint("id")
	name := post.Get("name")
	upath := post.Get("upath")
	if upath == "" {
		return c.ErrJSON(w, "请填写类空间")
	}
	ufunc := post.Get("ufunc")
	if ufunc == "" {
		return c.ErrJSON(w, "请填写函数名")
	}
	mockjson := post.Get("mockjson", c.CIYPOST_ALLOW_ALL)
	if mockjson == "" {
		return c.ErrJSON(w, "请填写JSON")
	}
	if mockjson[0:7] != "http://" {
		var jsn any
		err := json.Unmarshal([]byte(mockjson), &jsn)
		if err != nil {
			return c.ErrJSON(w, "JSON格式错误", err)
		}
	}

	var err error
	var datarow map[string]any
	if id > 0 {
		csql := c.NewCiySQL("zc_ymock")
		csql.Where("id", id)
		datarow, err = c.CiyDB.Getone(csql)
		if datarow == nil {
			return c.ErrJSON(w, "数据不存在", err)
		}
	}
	updata := map[string]any{}
	err = c.CiyDB.Tran(func() error {
		var csql *c.CiySQL
		csql = c.NewCiySQL("zc_ymock")
		csql.Where("upath", upath)
		csql.Where("ufunc", ufunc)
		csql.Column("id")
		chkid := c.Toint(c.CiyDB.Get1(csql))
		if chkid > 0 && ((id > 0 && chkid != id) || id == 0) {
			return fmt.Errorf("类函数重复")
		}
		updata["name"] = name
		updata["upath"] = upath
		updata["ufunc"] = ufunc
		updata["mockjson"] = mockjson
		csql = c.NewCiySQL("zc_ymock")
		if id > 0 {
			csql.Where("id", id)
			_, err = c.CiyDB.Update(csql, updata)
		} else {
			updata["addtimes"] = c.Tostamp()
			id, err = c.CiyDB.Insert(csql, updata)
		}
		updata["id"] = id
		if err != nil {
			return fmt.Errorf("更新失败:%v", err)
		}
		return nil
	})
	if err != nil {
		return c.ErrJSON(w, "事务"+err.Error())
	}
	ret := map[string]any{}
	ret["data"] = updata
	return c.SuccJSON(w, r, ret)
}
func Mock_del(w http.ResponseWriter, r *http.Request) bool {
	post := c.NewCiyPost(w, r)
	_, userid := admin.Verifyfast(r, c.CiyDB, post)
	if userid == 0 {
		return false
	}
	if admin.Nopower(c.CiyDB, userid, "p942u") {
		return c.ErrJSON(w, "您未被授权操作")
	}
	ids := post.Get("ids")
	if ids == "" {
		return c.ErrJSON(w, "请选择至少一条")
	}
	csql := c.NewCiySQL("zc_ymock")
	csql.Where("id in", ids)
	rows, _, err := c.CiyDB.Get(csql)
	if err != nil {
		return c.ErrJSON(w, "读取数据错误", err)
	}
	vids := make([]int, 0)
	err = c.CiyDB.Tran(func() error {
		for _, row := range rows {
			delid := c.Toint(row["id"])
			c.Delme(c.CiyDB, delid, "zc_ymock")
			vids = append(vids, delid)
		}
		return nil
	})
	if err != nil {
		return c.ErrJSON(w, "事务"+err.Error())
	}
	ret := map[string]any{}
	ret["ids"] = vids
	return c.SuccJSON(w, r, ret)
}
